#ifndef compiler_expression_expression_lambda_h
#define compiler_expression_expression_lambda_h

#include "expression_base.h"
#include "../utils/name2type.h"

#include <string>

//
// I dont want include these files,
// becouse code does not use them
//
//#include "../streams/stream_input.h"
//#include "../lexer/lexer.h"

namespace lexer
{
	class token;
}

namespace stream
{
	template<typename T>
	class input;
}

namespace expression
{
	//
	// Lambda expression
	class lambda : public base
	{
	public:

		// arranged in ./syntacter/syntacter_lambda.cpp
		static lambda* read(stream::input<lexer::token>& i);
		
		virtual ~lambda();

		virtual binary::link link(linker::context& c);
		virtual int estimateApply(linker::context& c, size_t argc, base** args);

	private:

		lambda();
		void addArgument(const std::string& a);
		void setListArgument(const std::string& a);
		void setFunction(base* e);

	private:

		base* m_function;
		name2index m_args;
		bool m_lastArgumentIsList;
		bool m_isEstimatedNow;
	};
}

#endif
