#ifndef compiler_streams_char_source_h
#define compiler_streams_char_source_h

#include "stream_input.h"
#include <istream>

class char_source : public stream::source<char>
{
public:

	char_source(std::istream& i) : m_input(i)
	{
	}

	virtual char get()
	{
		if (m_eofReached)
		{
			throw stream::eof();
		}

		if (m_input.eof())
		{
			m_eofReached = true;
			throw stream::eof();
		}

		int c = m_input.get();

		if (c == std::istream::traits_type::eof())
		{
			m_eofReached = true;
			throw stream::eof();
		}

		return c;
	}

private:

	std::istream& m_input;
};

#endif
