#ifndef compiler_streams_stream_output_h
#define compiler_streams_stream_output_h

#include <vector>

namespace stream
{
	//
	//    
	class output
	{
	public:

		//
		//   
		//

		int size() const
		{
			return (int)m_data.size();
		}

		char operator[](int index) const
		{
			return m_data[index];
		}

		const char* buffer() const
		{
			return &m_data[0];
		}

		//
		//   
		//

		output& operator << (bool b)
		{
			if (b)
			{
				m_data.push_back((char)1);
			}
			else
			{
				m_data.push_back((char)0);
			}

			return *this;
		}

		output& operator << (char c)
		{
			m_data.push_back(c);
			return *this;
		}

		output& operator << (int i)
		{
			write_back(&i, sizeof(i));
			return *this;
		}

		output& operator << (double d)
		{
			write_back(&d, sizeof(d));
			return *this;
		}

		output& operator << (const std::string& s)
		{
			write_back(s.c_str(), (int)s.length());
			return *this;
		}

		output& operator << (const output& o)
		{
			if (this != &o)
			{
				write_back(o.buffer(), (int)o.size());
			}

			return *this;
		}

		void write_back(const void* buff, int size)
		{
			int s = (int)m_data.size();
			m_data.resize(s + size);
			if (size != 0)
			{
				memcpy(&m_data[s], buff, size);
			}
		}

	private:

		std::vector<char> m_data;
	};
}

#endif
