#ifndef compiler_utils_name2type_h
#define compiler_utils_name2type_h

#include <string>
#include <map>

template <typename T>
class invalid
{
public:
	static T get()
	{
		return 0;
	}
};

template <>
class invalid<int>
{
public:
	static int get()
	{
		return -1;
	}
};

//
// Name-2-something translator
template<typename T>
class name2type
{
public:

	void add(const std::string& name, T value)
	{
		m_table[name] = value;
	}

	T operator[](const std::string& name) const
	{
		typename name2type_map::const_iterator i = m_table.find(name);

		if (i == m_table.end())
		{
			return invalid<T>::get();
		}

		return i->second;
	}

	size_t size() const
	{
		return m_table.size();
	}

private:

	typedef std::map<std::string, T> name2type_map;
	name2type_map m_table;
};


// Helper for name-2-index translation
typedef name2type<int> name2index;

// Helper for name-2-pointer translation
template<typename T>
class name2ptype : public name2type<T*>
{
};

#endif
