#ifndef compiler_utils_pointer_vector_h
#define compiler_utils_pointer_vector_h

#include <vector>

//
//  ,  ,
//     
template <class T>
class pointer_vector
{
public:

	typedef T* PT;

	pointer_vector() : m_data(0)
	{
	}

	~pointer_vector()
	{
		for (size_t i = 0; i < m_data.size(); i++)
		{
			delete m_data[i];
			m_data[i] = 0;
		}
	}

	size_t size() const
	{
		return m_data.size();
	}

	T** get() const
	{
		if (m_data.size() == 0)
		{
			return 0;
		}

		return (T**)(&m_data[0]);
	}

	const PT&  operator[] (size_t i) const
	{
		return m_data[i];
	}

	PT& operator[] (size_t i)
	{
		return m_data[i];
	}

	void set(size_t i, T* p)
	{
		m_data[i] = p;
	}

	void resize(size_t s)
	{
		m_data.resize(s);
	}

	void push_back(T* p)
	{
		m_data.push_back(p);
	}

private:

	std::vector<PT> m_data;
};

#endif
