#ifndef executer_context_context_h
#define executer_context_context_h

#include "context_base.h"
#include "../loader/loader.h"
#include <vector>

namespace context
{
	//
	// global program context
	class global : public base
	{
	public:

		global(const loader::executable& exe);

		virtual object::proxy get(binary::link l, bool separable) const;
		virtual object::proxy get(binary::link l, bool separable, const base* c) const;
		virtual const base* parent() const;

	private:

		const loader::executable& m_exe;
	};

	//
	// local function context
	class local : public base
	{
	public:

		local(const base* c);
		virtual ~local();

		void add(object::proxy p);

		virtual object::proxy get(binary::link l, bool separable) const;
		virtual object::proxy get(binary::link l, bool separable, const base* c) const;
		virtual const base* parent() const;

	private:

		//proxy m_parent;
		smartptr<base> m_parent;
		std::vector<object::proxy> m_local;
	};
}

#endif
