#ifndef executer_context_context_base_h
#define executer_context_context_base_h

#include "../utils/allocator.h"
#include "../utils/smartptr.h"

namespace object
{
	class proxy;
}

namespace binary
{
	union link;
}

namespace context
{
	//
	// Abstract context
	class base : protected refobject
	{
	public:

		virtual object::proxy get(binary::link l, bool separable) const = 0;
		virtual object::proxy get(binary::link l, bool separable, const base* c) const = 0;
		virtual const base* parent() const = 0;

		//using refobject::operator new;
		//using refobject::operator delete;

	protected:

		virtual ~base()
		{
		}

		friend class smartptr<base>;
	};
}

#endif
