#ifndef executer_loader_loader_h
#define executer_loader_loader_h

#include <vector>
#include "../utils/mmf.h"

namespace binary
{
	// predefinition
	struct record;
}

namespace loader
{
	//
	// Record in object table
	class record
	{
	public:

		record(const char* base = 0, const binary::record* rec = 0);

		short type() const;
		short flags() const;
		int estimate() const;

		const char* data() const;
		size_t size() const;

	private:

		const char* m_base;
		const binary::record* m_rec;
	};

	//
	// executable file 
	class executable
	{
	public:

		executable(const char* name);

		size_t size() const;
		const record& operator[](size_t i) const;

	private:

		std::vector<record> m_data;
		MemoryMappedFile m_mmf;
	};
};

#endif
